/* Converts a binary file into a C integer array (for inclusion in
   a source file) */

#include <stdio.h>

#define READBYTES			20

void convert(char *ifn, char *ofn) {
	FILE *i, *o;
	unsigned char buffer[READBYTES+10];
	int red, q, count=0;

	i = fopen(ifn, "rb");
	o = fopen(ofn, "w");

	if (!i) {
		printf("error: can't open input file\n");
		return;
	}
	if (!o) {
		printf("error: can't open output file\n");
		return;
	}

	fprintf(o, "/* generated by bin2c from file %s */\n", ifn);

	do {
		red = fread(buffer, 1, READBYTES, i);
		for (q=0; q<red; q++) {
			fprintf(o, "0x%02X, ", buffer[q]);
			if ((count % 300) == 0) printf(".");
			count++;
		}
		fprintf(o, "\n");
	} while (red == READBYTES);

	fclose(i); fclose(o);
}

int main(int argc, char **argv) {
	argc--;
	if (argc != 2) {
		printf("usage: bin2c <input> <output>\n");
		return 0;
	}

	convert(argv[1], argv[2]);

	return 0;
}

